var DATA = {};

var SUPPORTED = [
  'gen1randombattle', 'gen2randombattle',  'gen3randombattle',
  'gen4randombattle', 'gen5randombattle', 'gen6randombattle',
  'gen7randombattle', 'gen7letsgorandombattle', 'gen7randomdoublesbattle',
  'gen8bdsprandombattle', 'gen8randombattle', 'gen8randombattleblitz',
  'gen8randombattlenodmax', 'gen8randomdoublesbattle',
];
// Weakness chart
var ShowdownEnhancedTooltip = {};

ShowdownEnhancedTooltip.Settings = {
  showBaseStats: 'OFF',
};

ShowdownEnhancedTooltip.BattleTypeChart = {
  // defending type
  "Bug": {
    damageGiven: {
      // attacking type : effectivenessMultiplier
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 0.5,
      "Fire": 2,
      "Flying": 2,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 0.5,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 2,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"atk":30, "def":30, "spd":30},
    HPdvs: {"atk":13, "def":13},
  },
  "Dark": {
    damageGiven: {
      "Bug": 2,
      "Dark": 0.5,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 2,
      "Fighting": 2,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 0.5,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 0,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {},
  },
  "Dragon": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 2,
      "Electric": 0.5,
      "Fairy": 2,
      "Fighting": 1,
      "Fire": .5,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 1,
      "Ice": 2,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 1,
      "Water": 0.5,
    },
    HPivs: {"atk":30},
    HPdvs: {"def":14},
  },
  "Electric": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 0.5,
      "Fairy": 1,
      "Fighting": 1,
      "Fire": 1,
      "Flying": 0.5,
      "Ghost": 1,
      "Grass": 1,
      "Ground": 2,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 0.5,
      "Water": 1,
    },
    HPivs: {"spa":30},
    HPdvs: {"atk":14},
  },
  "Fairy": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 0.5,
      "Dragon": 0,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 0.5,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 2,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 2,
      "Water": 1,
    },
  },
  "Fighting": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 0.5,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 2,
      "Fighting": 1,
      "Fire": 1,
      "Flying": 2,
      "Ghost": 1,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 2,
      "Rock": 0.5,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"def":30, "spa":30, "spd":30, "spe":30},
    HPdvs: {"atk":12, "def":12},
  },
  "Fire": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 0.5,
      "Fighting": 1,
      "Fire": 0.5,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 2,
      "Ice": 0.5,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 2,
      "Steel": 0.5,
      "Water": 2,
    },
    HPivs: {"atk":30, "spa":30, "spe":30},
    HPdvs: {"atk":14, "def":12},
  },
  "Flying": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 2,
      "Fairy": 1,
      "Fighting": 0.5,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 0,
      "Ice": 2,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 2,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"hp":30, "atk":30, "def":30, "spa":30, "spd":30},
    HPdvs: {"atk":12, "def":13},
  },
  "Ghost": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 2,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 0,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 2,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 0,
      "Poison": 0.5,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"def":30, "spd":30},
    HPdvs: {"atk":13, "def":14},
  },
  "Grass": {
    damageGiven: {
      "Bug": 2,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 0.5,
      "Fairy": 1,
      "Fighting": 1,
      "Fire": 2,
      "Flying": 2,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 0.5,
      "Ice": 2,
      "Normal": 1,
      "Poison": 2,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 1,
      "Water": 0.5,
    },
    HPivs: {"atk":30, "spa":30},
    HPdvs: {"atk":14, "def":14},
  },
  "Ground": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 0,
      "Fairy": 1,
      "Fighting": 1,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 2,
      "Ground": 1,
      "Ice": 2,
      "Normal": 1,
      "Poison": 0.5,
      "Psychic": 1,
      "Rock": 0.5,
      "Steel": 1,
      "Water": 2,
    },
    HPivs: {"spa":30, "spd":30},
    HPdvs: {"atk":12},
  },
  "Ice": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 2,
      "Fire": 2,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 1,
      "Ground": 1,
      "Ice": 0.5,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 2,
      "Steel": 2,
      "Water": 1,
    },
    HPivs: {"atk":30, "def":30},
    HPdvs: {"def":13},
  },
  "Normal": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 2,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 0,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
  },
  "Poison": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 0.5,
      "Fighting": 0.5,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 2,
      "Ice": 1,
      "Normal": 1,
      "Poison": 0.5,
      "Psychic": 2,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"def":30, "spa":30, "spd":30},
    HPdvs: {"atk":12, "def":14},
  },
  "Psychic": {
    damageGiven: {
      "Bug": 2,
      "Dark": 2,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 0.5,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 2,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 0.5,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"atk":30, "spe":30},
    HPdvs: {"def":12},
  },
  "Rock": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 2,
      "Fire": 0.5,
      "Flying": 0.5,
      "Ghost": 1,
      "Grass": 2,
      "Ground": 2,
      "Ice": 1,
      "Normal": 0.5,
      "Poison": 0.5,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 2,
      "Water": 2,
    },
    HPivs: {"def":30, "spd":30, "spe":30},
    HPdvs: {"atk":13, "def":12},
  },
  "Steel": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 1,
      "Dragon": 0.5,
      "Electric": 1,
      "Fairy": 0.5,
      "Fighting": 2,
      "Fire": 2,
      "Flying": 0.5,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 2,
      "Ice": 0.5,
      "Normal": 0.5,
      "Poison": 0,
      "Psychic": 0.5,
      "Rock": 0.5,
      "Steel": 0.5,
      "Water": 1,
    },
    HPivs: {"spd":30},
    HPdvs: {"atk":13},
  },
  "Water": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 2,
      "Fairy": 1,
      "Fighting": 1,
      "Fire": 0.5,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 2,
      "Ground": 1,
      "Ice": 0.5,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 0.5,
      "Water": 0.5,
    },
    HPivs: {"atk":30, "def":30, "spa":30},
    HPdvs: {"atk":14, "def":13},
  },
};


ShowdownEnhancedTooltip.getTypeEff = function(types){
  if (types.length == 1){
    var damage = ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven;
  }else{
    var damage = {
      "Bug": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Bug * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Bug,
      "Dark": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Dark * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Dark,
      "Dragon": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Dragon * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Dragon,
      "Electric": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Electric * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Electric,
      "Fairy": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Fairy * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Fairy,
      "Fighting": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Fighting * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Fighting,
      "Fire": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Fire * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Fire,
      "Flying": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Flying * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Flying,
      "Ghost": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Ghost * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Ghost,
      "Grass": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Grass * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Grass,
      "Ground": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Ground * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Ground,
      "Ice": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Ice * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Ice,
      "Normal": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Normal * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Normal,
      "Poison": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Poison * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Poison,
      "Psychic": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Psychic * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Psychic,
      "Rock": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Rock * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Rock,
      "Steel": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Steel * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Steel,
      "Water": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Water * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Water,
    }
  }

  var typeEff = {
    "4": [],
    "2": [],
    "1": [],
    "0.5": [],
    "0.25": [],
    "0": []
  };

  for(var index in damage) {
    var eff = damage[index];
    typeEff[eff].push(index);
  }

  return typeEff;
};

// Random Battle sets are generated based on battle-only forms which makes disambiguating sets
// difficult sometimes. We first try searching by level as sometimes this is sufficient to
// differentiate and then by base species - if there is only one set then we can return it.
// Otherwise, if the Pokémon is not the base forme and there is only one set for that forme we can
// return that. However, if the Pokémon is still in its base forme we return multiple (labelled)
// sets.
var TOOLTIP = undefined;
try { TOOLTIP = BattleTooltips.prototype.showPokemonTooltip; } catch {}
if (TOOLTIP) {
  for (var format of SUPPORTED) {
    (function (f) {
      var request = new XMLHttpRequest();
      request.addEventListener('load', function() {
        var data = {};
        var json = JSON.parse(request.responseText);
        for (var name in json) {
          var pokemon = json[name];
          data[pokemon.level] = data[pokemon.level] || {};
          var species = Dex.species.get(name);
          var id = toID(species.forme === 'Gmax'
            ? species.baseSpecies
            : species.battleOnly || species.name);
          data[pokemon.level][id] = data[pokemon.level][id] || [];
          data[pokemon.level][id].push(Object.assign({name: name}, pokemon));
        }
        DATA[f] = data;
      });
      request.open('GET', 'https://pkmn.github.io/randbats/data/' + f + '.json');
      request.send(null);
    })(format);
  }

  BattleTooltips.prototype.showPokemonTooltip = function (clientPokemon, serverPokemon) {
    var original = TOOLTIP.apply(this, arguments);
    if (!clientPokemon || serverPokemon) return original;
    var format = toID(this.battle.tier);
    if (!format || !format.includes('random')) return original;

    var species = Dex.species.get(clientPokemon.speciesForme);
    if (!species) return original;

    var gen = Number(format.charAt(3));
    var letsgo = format.includes('letsgo');
    var gameType = this.battle.gameType;

    if (!['singles', 'doubles'].includes(gameType)) {
      format = 'gen' + gen + 'randomdoublesbattle';
    } else if (format.includes('monotype') || format.includes('unrated')) {
      format = 'gen' + gen + 'randombattle';
    }
    if (!DATA[format]) return original;

    var data = DATA[format][species.name === 'Zoroark' ? 0 : clientPokemon.level];
    if (!data) return original;

    var cosmetic = species.cosmeticFormes && species.cosmeticFormes.includes(species.name);
    var id = toID((species.forme === 'Gmax' || cosmetic)
      ? species.baseSpecies : species.battleOnly || species.name);
    if (id.startsWith('pikachu')) id = id.endsWith('gmax') ? 'pikachugmax' : 'pikachu';
    var forme = cosmetic ? species.baseSpecies : clientPokemon.speciesForme;
    if (forme.startsWith('Pikachu')) forme = forme.endsWith('Gmax') ? 'Pikachu-Gmax' : 'Pikachu';

    data = data[id];
    if (!data) return original;

    if (data.length === 1) {
      data[0].level = clientPokemon.level;
      return original + displaySet(gen, gameType, letsgo, species, data[0], null , this.getPokemonTypes(clientPokemon));
    }
    if (toID(forme) !== id) {
      var match = [];
      for (var set of data) {
        set.level = clientPokemon.level;
        if (set.name === forme) match.push(displaySet(gen, gameType, letsgo, species, set, null , this.getPokemonTypes(clientPokemon)));
      }
      if (match.length === 1) return original + match[0];
    }
    var buf = original;
    for (var set of data) {
      set.level = clientPokemon.level;
      // Technically different formes will have different base stats, but given at this stage
      // we're still in the base forme we simply use the base forme base stats for everything.
      buf += displaySet(gen, gameType, letsgo, species, set, set.name, this.getPokemonTypes(clientPokemon));
    }
    return buf;
  }

  function displaySet(gen, gameType, letsgo, species, data, name, types) {
    var stats = {};
    for (var stat in species.baseStats) {
      stats[stat] = calc(
        gen,
        stat,
        species.baseStats[stat],
        'ivs' in data && stat in data.ivs ? data.ivs[stat] : (gen < 3 ? 30 : 31),
        'evs' in data && stat in data.evs ? data.evs[stat] : (gen < 3 ? 255 : letsgo ? 0 : 85),
        data.level,
        letsgo);
    }
    var moves = data.moves;
    var noHP = true;
    var multi = !['singles', 'doubles'].includes(gameType);
    var ms = [];
    for (var move of moves) {
      if (move.startsWith('Hidden Power')) noHP = false;
      if (!(multi && move === 'Ally Switch')) ms.push(move);
    }

    var buf = '<div style="border-top: 1px solid #888; background: #dedede">';
    if (name) buf += '<p><b>' + name + '</b></p>';
    if (gen >= 3 && !letsgo) {
      buf += '<p><small>Abilities:</small> ' + data.abilities.join(', ') + '</p>';
    }
    if (gen >= 2 && !(letsgo && !data.items)) {
      buf +=
        '<p><small>Items:</small> ' + (data.items ? data.items.join(', ') : '(No Item)') + '</p>';
    }

    buf += '<p><small>Moves:</small> ' + moves.join(', ') + '</p>';
    
    const typeEff = ShowdownEnhancedTooltip.getTypeEff(types);
    const multiplierKeys = [4, 2, .5, .25, 0];
    buf += '<p>Weaknesses: <br />';
    multiplierKeys.forEach((multiplierKey) => {
      if (typeEff[multiplierKey].length > 0) {
        const weakTypes = typeEff[multiplierKey].map(effect => effect ? Dex.getTypeIcon(effect) : '').join('');
        buf += `<p>${multiplierKey}x: ${weakTypes}</p>`;
        }
    });


    buf += '<p>';
    for (var statName of Dex.statNamesExceptHP) {
      if (gen === 1 && statName === 'spd') continue;
      var known = gen === 1 || (gen === 2 && noHP) ||
        ('ivs' in data && statName in data.ivs) || ('evs' in data && statName in data.evs);
      var statLabel = gen === 1 && statName === 'spa' ? 'spc' : statName;
      buf += statName === 'atk' ? '<small>' : '<small> / ';
      buf += '' + BattleText[statLabel].statShortName + '&nbsp;</small>';
      var italic = !known && (statName === 'atk' || statName === 'spe');
      buf += (italic ? '<i>' : '') + stats[statName] + (italic ? '</i>' : '');
    }
    buf += '</p>';

    buf += '</div>';
    console.log(buf);
    return buf;
  }

  function tr(num) {
    return num >>> 0
  }

  function calc(gen, stat, base, iv, ev, level, letsgo) {
    if (gen < 3) iv = Math.floor(iv / 2) * 2;
    if (stat === 'hp') {
      var val = base === 1 ? base : tr(tr(2 * base + iv + tr(ev / 4) + 100) * level / 100 + 10);
      return letsgo ? val + 20 : val;
    } else {
      var val = tr(tr(2 * base + iv + tr(ev / 4)) * level / 100 + 5);
      return letsgo ? tr(val * 102 / 100) + 20 : val;
    }
  }
}